// All code is copyright 2004 by George Harth <george@modeblue.com>
// except portions of EventSink.h and EventSink.cpp taken from
// an eSignal sample appliction

// ESigTimeAndSalesCppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ESigTimeAndSalesCpp.h"
#include "ESigTimeAndSalesCppDlg.h"
#include ".\esigtimeandsalescppdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CESigTimeAndSalesCppDlg dialog



CESigTimeAndSalesCppDlg::CESigTimeAndSalesCppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CESigTimeAndSalesCppDlg::IDD, pParent)
	, m_Username(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CESigTimeAndSalesCppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_USERNAME_EDIT, m_Username);
	DDX_Text(pDX, IDC_SYMBOL_EDIT, m_Symbol);
	DDX_Control(pDX, IDC_BUTTON1, m_GetDataButton);
}

BEGIN_MESSAGE_MAP(CESigTimeAndSalesCppDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CESigTimeAndSalesCppDlg message handlers

BOOL CESigTimeAndSalesCppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CRect rc;
	GetClientRect(&rc);
	rc.DeflateRect(5, 45, 5, 5);
	m_TimeAndSalesPane.QuickCreate(rc, this);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CESigTimeAndSalesCppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CESigTimeAndSalesCppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CESigTimeAndSalesCppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CESigTimeAndSalesCppDlg::OnClose()
{
	CDialog::OnClose();
}

void CESigTimeAndSalesCppDlg::OnBnClickedButton1()
{
	UpdateData(TRUE);
	m_Username.Trim();
	m_Symbol.Trim();
	if (m_Username.IsEmpty()) {
		MessageBox("Please enter your username");
	}
	else if (m_Symbol.IsEmpty()) {
		MessageBox("Please enter a symbol");
	}
	else {
		m_GetDataButton.EnableWindow(FALSE);
		g_ESignalConv.Connect("username");
		g_ESignalConv.RequestTimeSales(m_Symbol, 1, true, true, &m_TimeAndSalesPane);

		// Until the IsTimeSalesHistoryReady function is implemented (7.6 I believe)
		// we might need to jump start and refresh with a timer.  Currently
		// a redraw is only done when a new tick comes in, but on slower stocks
		// or after hours, this might not occur right away
		SetTimer(12345, 5000, NULL);
	}
}

void CESigTimeAndSalesCppDlg::OnTimer(UINT nIDEvent)
{
	if (nIDEvent == 12345) {
		m_TimeAndSalesPane.InvalidateRect(NULL);
		KillTimer(12345);	// Assume we have had some data returned and can now wait for new stuff

		// Might as well also check entitlement here
		if (!g_ESignalConv.IsEntitled()) {
			MessageBox("IsEntitled returned false");
		}
	}
	else CDialog::OnTimer(nIDEvent);
}
