// All code is copyright 2004 by George Harth <george@modeblue.com>
// except portions of EventSink.h and EventSink.cpp taken from
// an eSignal sample appliction

#if !defined(AFX_EVENTSINK_H__F1A241BD_6959_4030_9991_74D5C52B2667__INCLUDED_)
#define AFX_EVENTSINK_H__F1A241BD_6959_4030_9991_74D5C52B2667__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EventSink.h : header file
//

#include "stdafx.h"

inline CString  B2S(_bstr_t b) {
   //CString s((LPWSTR)b);
   CString s;
	s = (PCSTR)(char *)b;
	return s;
}

inline _bstr_t S2B(CString s) {
   BSTR bstr = s.AllocSysString();  

   return _bstr_t(bstr, TRUE);
}

inline CString D2S(int n, BOOL bClearZero = FALSE) {
	CString s;
	s.Format("%d", n);
	if(bClearZero && n == 0)
		return "";
	return s;
}

inline CString G2S(double d) {
	CString s;
	s.Format("%.2f", d);
	return s;
}

inline barType S2BT(CString s) {
   if (s == "DAYS")
   {
      return btDAYS;
   }
   return btBARS;
}

inline long S2L(CString s) {

   return (long)atoi(s);
}

inline CString L2S(long l) {
	char c;
	int i;
	CString s ="";
	
	while (l > 0)
	{
		i = (l%10);
		c = i+48;
		s += c;
		l = (l-i)/10;

	}
	s.MakeReverse();
	return s;
}


class EventSinkListener {
public:
	EventSinkListener() { }
	virtual ~EventSinkListener() { }

	virtual void ES_OnTimeSalesChanged(long l) = 0;
};

class CTimeSalesConsumer {
public:
	virtual void SetHandle(long lHandle) = 0;
	virtual void OnTimeSalesChanged(long lHandle) = 0;
};

/////////////////////////////////////////////////////////////////////////////
// EventSink command target

class EventSink : public CCmdTarget
{
	DECLARE_DYNCREATE(EventSink)

	EventSink();
	EventSink(EventSinkListener *pListener);           // protected constructor used by dynamic creation
	virtual ~EventSink();

private:
	EventSinkListener *m_pListener;

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EventSink)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(EventSink)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(EventSink)
	  afx_msg SCODE OnSymbolChanged(BSTR symbol);
	  afx_msg SCODE OnQuoteChanged(LPTSTR symbol);
     afx_msg SCODE OnBarsChanged(long lHandle);
     afx_msg SCODE OnBarsReceived(long lHandle);
     afx_msg SCODE OnPlaceOrder(LPTSTR xmlOrder);
     afx_msg SCODE OnTimeSalesChanged(long lHandle);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
};


class CESignalConv : public EventSinkListener {
public:
	CESignalConv();
	virtual ~CESignalConv();

	bool Connect(LPCTSTR username);
	void Disconnect();

	bool IsEntitled();
	bool IsHistoryReady(long lHandle);
	bool RequestTimeSales(LPCTSTR symbol, long numDays, bool bQuotes, bool bTrades, CTimeSalesConsumer* pConsumer);

	void ES_OnTimeSalesChanged(long lHandle);
	bool GetTimeSalesBar(long lHandle, long index, TimeSalesData& ts);

protected:
	IHooksPtr* m_piHooks;
	EventSink* m_pEvents;
	DWORD m_dwCookie;

	CMapPtrToPtr m_TickMap;	// Hold map of esignal handles to tick arrays for filling

	//CTickArray* m_TickArrays[2048];
};

// We want to create only one instance of CESignalConv to share globally
// so might as well do it here
extern CESignalConv g_ESignalConv;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EVENTSINK_H__F1A241BD_6959_4030_9991_74D5C52B2667__INCLUDED_)
